precision mediump float;
attribute vec2 attrib0;
uniform mat4 uMVMatrix;
void main() {
    gl_Position = uMVMatrix * vec4(attrib0, 1.0, 1.0);
}

[FS]
precision mediump float;
uniform vec4 uData[2];

#if __VERSION__ >= 300
    layout(location = 0) out vec4 fragData_0;
#endif

#if (defined(GPU_YEAR) && (GPU_YEAR < 2013)) || (__VERSION__ < 300)
    #define PIX 0.0000001
#else
    #define PIX length(fwidth(gl_FragCoord.xy))
#endif

void main() {
    float dist = length(gl_FragCoord.xy - uData[1].xy);
    dist = max(dist - uData[1].z, uData[1].w - dist);
    float a = smoothstep(0.0,-PIX, dist);
    gl_FragColor = uData[0] * a; // PMA
}