attribute vec3 attrib0;
attribute vec2 attrib1;
attribute vec2 attrib2;
#ifdef COVER
    attribute vec4 attrib3;
#endif

uniform mat4 uMVMatrix;
uniform vec4 uLayer0;
uniform vec4 uLayer1;

varying vec2 vTexCoord0;
varying vec2 vTexCoord1;
#ifdef COVER
    varying vec4 vCover;
#endif

void main() {
    gl_Position = uMVMatrix * vec4(attrib0.xy, 1.0, 1.0);
    vTexCoord0 = vec2(attrib1.x, 1.0 - attrib1.y) + uLayer0.xy;
    vTexCoord1 = vec2(attrib2.x, 1.0 - attrib2.y) + uLayer1.xy;
    #ifdef COVER
        vCover = attrib3;
    #endif
}

[FS]
precision mediump float;

varying vec2 vTexCoord0;
varying vec2 vTexCoord1;
#ifdef COVER
    varying vec4 vCover;
#endif

uniform sampler2D tex0;
uniform vec4 uData;
uniform vec4 uBackground;

#if __VERSION__ >= 300
    layout(location = 0) out vec4 fragData_0;
#endif

void main() {
    #ifdef COVER
        vec4 v2 = uData * (1.0 - vCover.w);
        vec4 v3 = uBackground * (1.0 - vCover.w) + vCover;
    #else
        vec4 v2 = uData;
        vec4 v3 = uBackground;
    #endif
    float w = texture(tex0, vTexCoord0).w + texture(tex0, vTexCoord1).w;
    gl_FragColor = v2 * w + v3;
}