attribute vec3 attrib0;
attribute vec3 attrib1;
attribute vec2 attrib2;
uniform mat4 uMVMatrix;
varying vec3 vNormal;
varying vec2 vTextureCoord;

void main(void) {
    gl_Position = uMVMatrix * vec4(attrib0, 1.0);
    vNormal = normalize(attrib1);
    vTextureCoord = attrib2;
}

[FS]
precision mediump float;
uniform sampler2D tex0;
varying vec3 vNormal;
varying vec2 vTextureCoord;
uniform vec4 uLight;
uniform vec4 uCover;

#if __VERSION__ >= 300
    layout(location = 0) out vec4 fragData_0;
#endif

void main(void) {
    vec3 Normal3 = normalize( gl_FrontFacing ? -vNormal : vNormal );
    float Normal = max(  SHADOW_FACTOR , Normal3.z );
    gl_FragColor = (texture(tex0, vTextureCoord) * uLight + uCover) * vec4(Normal,Normal,Normal,1.0);
}