attribute vec2 attrib0;
attribute vec2 attrib1;
attribute vec4 attrib2;
attribute vec4 attrib3;

uniform mat4 uMVMatrix;
varying vec2 vTextureCoord;
varying vec4 vLight;
varying vec4 vCover;

void main(void) {
    gl_Position = uMVMatrix * vec4(attrib0, 1.0, 1.0);
    vTextureCoord = attrib1;
    vLight = attrib2;
    vCover = attrib3;
}

[FS]
precision mediump float;
uniform sampler2D tex0;
varying vec2 vTextureCoord;
varying vec4 vLight;
varying vec4 vCover;

#if __VERSION__ >= 300
    layout(location = 0) out vec4 fragData_0;
#endif

void main(void) {
    #ifdef NOTEX
        vec4 c = vec4(1.0);
    #else
        vec4 c = texture(tex0, vTextureCoord);
    #endif
    #ifdef WITH_DISCARD
        if ( c.a < 0.01 ) discard;
    #endif
    #ifdef PMA
        c.rgb = c.rgb * vLight.rgb * vLight.a + vCover.rgb * c.a * vLight.a;
        c.a = c.a * vLight.a;
        gl_FragColor = c;
    #else
        gl_FragColor = c * vLight + vCover;
    #endif
}