attribute vec2 attrib0;
attribute vec2 attrib1;
attribute float attrib2;
attribute float attrib3;
attribute float attrib4;

uniform float uTime;
uniform float uBlinkPeriod;
uniform float uAlpha;
uniform mat4 uMVMatrix;
varying vec2 vTexCoord;
varying float vAlpha;
float particleTime;
float t;
float tBlink;

void main(void) {
    gl_Position = uMVMatrix * vec4(attrib0.xy, 1.0, 1.0);
    vTexCoord = attrib1;
    particleTime = uTime - attrib2;
    t = fract(particleTime / attrib3); //[0..1)
    tBlink = uBlinkPeriod / attrib3; 
    vAlpha = 2.0 * abs(t / tBlink - 0.5) * attrib4 * uAlpha;
    if (t >= tBlink) vAlpha = attrib4 * uAlpha;
}

[FS]
precision mediump float;
varying vec2 vTexCoord;
varying float vAlpha;
uniform sampler2D tex0;

#if __VERSION__ >= 300
    layout(location = 0) out vec4 fragData_0;
#endif

void main(void) {
    gl_FragColor = texture(tex0, vTexCoord) * vec4(1.0, 1.0, 1.0, vAlpha);
}