// https://www.gdcvault.com/play/203/Fast-Water-Simulation-for-Games

attribute vec2 attrib0;
attribute vec2 attrib1;
varying vec2 coord0;

void main() {
    gl_Position = vec4(attrib0, 1.0, 1.0);
    coord0 = attrib1;
}

[FS]
precision mediump float;

uniform sampler2D tex0; // spring
uniform sampler2D tex1; // liquid
uniform vec2 resolution;

varying vec2 coord0;

#if __VERSION__ >= 300
    layout(location = 0) out vec4 fragData_0;
#endif

vec3 combineNormals1(vec3 n0, vec3 n1) {
    return vec3(n0.xy + n1.xy, n0.z * n1.z);
}

vec3 getNormal(sampler2D buf, vec2 uv, vec2 p, float h) {
    float p0 = texture(buf, uv + p * vec2(-1, 0)).x;
    float p2 = texture(buf, uv + p * vec2( 0,-1)).x;	
    return normalize(vec3((p0 - h), (p2 - h), 1.0));
}

float maxcomp(vec2 v) { return max(v.x,v.y); }

void main() {
	vec2 uv = coord0;
    vec2 p = 1.0 / resolution.xy;
    
    // vec3 n1 = getNormal(tex0,uv,p);
    float height = texture(tex1, uv).x;
    vec3 n2 = getNormal(tex1,uv,p,height);
    n2.xy *= mix(0.0,4.0, smoothstep(0.495,0.48,maxcomp(abs(uv-0.5))));    
    
    // vec3 n = combineNormals1(n1,n2);    
    vec3 n = normalize(n2);

    gl_FragColor = vec4(n*0.5+0.5, height);
    // gl_FragColor = texture(tex1,uv);
}