attribute vec2 attrib0;
attribute vec2 attrib1;
attribute float attrib2;

uniform float uTime;
uniform float uFrameWidth;
uniform float uFrameCount;
uniform float uPeriodMs;
uniform float uWaveShiftXDiameter;
uniform mat4 uMVMatrix;
varying vec2 vTexCoord;
float particleTime;
float t;
float index;
float frameIndex;
float xShift;

void main(void) {
    particleTime = uTime - attrib2;

    t = fract(particleTime / uPeriodMs);
    index = floor(particleTime / uPeriodMs);
    frameIndex = floor(t * uFrameCount);
    vTexCoord.x = attrib1.x + frameIndex * uFrameWidth;
    vTexCoord.y = attrib1.y;
    xShift = fract(index * 0.168072918392173) * uWaveShiftXDiameter;
    gl_Position = uMVMatrix * vec4(attrib0.x + xShift, attrib0.y, 1.0, 1.0);
}

[FS]
precision mediump float;
varying vec2 vTexCoord;
uniform sampler2D tex0;
uniform vec4 uColor;

#if __VERSION__ >= 300
    layout(location = 0) out vec4 fragData_0;
#endif

void main(void) {
    gl_FragColor = texture(tex0, vTexCoord) * uColor;
}